%define courier_piddir %_var/run
%define _ssldir %(openssl-config --openssldir)
%define _pemdir %_ssldir/certs

Name: courier-imap
Version: 1.6.2
Release: alt3

Summary: IMAP/POP3 server with Maildir support
License: GPL
Group: Networking/Mail
URL: http://www.courier-mta.org

Requires: courier-common-utils
PreReq: chkconfig, %_ssldir
Obsoletes: courier-imap-doc

###########################################
# Relations with other POP3/IMAP server pkgs (like courier-imap)

# Provide the abstract service names (which are virtual pkg names),
# specify their origin (our pkg name as the epoch + version-release):
Provides: IMAPD = %name:%version-%release
Provides: POP3D = %name:%version-%release

# Conflict with all other real pkgs which provide the same services
# (they should specify the origin the same way, so the epoch-version-release
# of the virtual pkgs POP3D & IMAPD will always differ from that of ours if
# they are provided by a different real pkg):
Conflicts: IMAPD < %name:%version-%release
Conflicts: IMAPD > %name:%version-%release
Conflicts: POP3D < %name:%version-%release
Conflicts: POP3D > %name:%version-%release

# End of the statements to describe relations with other POP3/IMAP server pkgs
########################################

# Automatically added by buildreq on Tue Feb 04 2003
BuildRequires: drac-devel-static expect gcc-c++ libMySQL-devel libdb4-devel
BuildRequires: libfam-devel libldap-devel libpam-devel libpq3-devel libssl-devel
BuildRequires: libstdc++-devel openssl postgresql-devel zlib-devel


Source0: %name-%version.tar.bz2
Source1: courier-imap.sysconfig
Source2: courier-authdaemon.init
Source3: courier-imapd.init
Source4: courier-imapd-ssl.init
Source5: courier-pop3d.init
Source6: courier-pop3d-ssl.init
Source7: %name.README-ALT

# Add support for DRAC (POP-BEFORE-SMTP) feature to POP3/IMAP4 servers.
# See package drac-1.11 and http://mail.cc.umanitoba.ca/drac/
# for additional info.
Patch0: %name-1.6.2-alt-DRAC.patch

# Virtual hosting feature: username at login stage can be specified as:
#	user@virtual.domain
#	user#virtual.domain
#	user/virtual.domain
#
# '#' and '/' formats need in case if mailprogramm does't accept 
# '@' format as mailbox login (old versions of Netscape mail
# clients for example)
Patch1: %name-1.6.2-alt-virthosting.patch

# Add logging of username and ip-address to POP3/IMAP4 daemons
# at LOGIN stage. This is need especialy for ISPs (for see if someone
# try to login with wrong password or try to search valid logins, etc.)
Patch2: %name-1.6.2-alt-logging.patch

# Fix some Courier-IMAP config files
Patch3: %name-1.6.2-alt-config.patch

# Fix manual page and html-doc for pop3d
Patch4: %name-1.6.2-alt-man.patch

# Fix some install paths
Patch5: %name-1.6.2-alt-makefile.patch

# Fix paths to PEM-files in the mkpop3dcert and mkimapdcert scripts
Patch6: %name-1.5.3-alt-scripts.patch

# Rename userdb.dat and userdbshadow.dat to userdb.db and userdbshadow.db
#  this need in case of using this DB's as source for sendmail/postfix hash maps.
Patch7: %name-1.5.3-alt-userdb.patch

# Place .pid and .lock files according to FHS
Patch8: %name-1.6.2-alt-fhs.patch

%description
Courier-IMAP is an IMAP server for Maildir mailboxes.  This package contains
the standalone version of the IMAP server that's included in the Courier
mail server package.  This package is a customized version for use with
other mail servers. DRAC (http://mail.cc.umanitoba.ca/drac/index.html) support
included.

%package utils
Summary: Common utilities for Courier-IMAP package
Group: Networking/Mail
Provides: courier-common-utils
Conflicts: maildrop-utils

%description utils
This package contains the necessary files to allow Courier-IMAP
authenticate users via LDAP directory. Install this package if you
need the ability to use an LDAP directory for authentication.

%package userdb
Summary: Courier-IMAP USERDB authentication driver
Group: Networking/Mail
Requires: %name = %version-%release, courier-common-utils

%description userdb
This package contains the necessary files to allow Courier-IMAP
authenticate users via USERDB mechainsm. Install this package if you
need the ability to use an USERDB mechainsm for authentication.

%package ldap
Summary: Courier-IMAP LDAP authentication driver
Group: Networking/Mail
Requires: %name = %version-%release, courier-common-utils

%description ldap
This package contains the necessary files to allow Courier-IMAP
authenticate users via LDAP directory. Install this package if you
need the ability to use an LDAP directory for authentication.

%package mysql
Summary: Courier-IMAP MySQL authentication driver
Group: Networking/Mail
Requires: %name = %version-%release, courier-common-utils

%description mysql
This package contains the necessary files to allow Courier-IMAP to
authenticate users via MySQL database table.  Install this package if you
need the ability to use a MySQL database table for authentication.

%package pgsql
Summary: Courier-IMAP PostgreSQL authentication driver
Group: Networking/Mail
Requires: %name = %version-%release, courier-common-utils

%description pgsql
This package contains the necessary files to allow Courier-IMAP to
authenticate users via PostgreSQL database table. Install this package if
you need the ability to use a PostgreSQL database table for authentication.

%prep
%setup
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1

%build
%configure \
  --sysconfdir=%_sysconfdir/%name \
  --libexecdir=%_libdir/%name \
  --with-userdb=%_sysconfdir/%name/userdb \
  --with-makedatprog=%_datadir/%name/makedatprog \
  --with-db=db \
    --enable-unicode \
    --with-piddir=%courier_piddir \
    --without-ipv6 \
 --with-authdaemon \
 --with-authdaemonrc=%_sysconfdir/%name/authdaemon.conf \
 --with-authdaemonvar=%_localstatedir/%name \
 --with-authchangepwdir=%_datadir/%name/authlib \
 --with-authldaprc=%_sysconfdir/%name/authdaemon-ldap.conf \
 --with-authpgsqlrc=%_sysconfdir/%name/authdaemon-pgsql.conf \
 --with-authmysqlrc=%_sysconfdir/%name/authdaemon-mysql.conf \
 --with-pgsql-libs=/usr/lib \
 --with-pgsql-includes=/usr/include/pgsql \
 --with-mysql-libs=/usr/lib \
 --with-mysql-includes=/usr/include/mysql

%make_build

%install

# adjust $RPM_BUILD for install
%__mkdir_p -m 0700 %buildroot/%_pemdir
%__mkdir_p %buildroot/%_sysconfdir/pam.d
%__mkdir_p %buildroot/%_initdir
%__mkdir_p %buildroot/%_sysconfdir/sysconfig
%__mkdir_p %buildroot/%_docdir/%name-%version/html

%__make DESTDIR=%buildroot install

# tune configfiles
for i in `ls %buildroot/%_sysconfdir/%name/*.dist | %__sed -e 's/\.dist//'`; do
	%__mv $i.dist $i
done

# install configs and inint scripts
%__install -D -m 0644 maildir/quotawarnmsg %buildroot/%_sysconfdir/%name/quotawarnmsg.example
%__install -m 0644 %SOURCE1 %buildroot/%_sysconfdir/sysconfig/%name
%__install -m 0755 %SOURCE2 %buildroot/%_initdir/courier-authdaemon
%__install -m 0755 %SOURCE3 %buildroot/%_initdir/courier-imapd
%__install -m 0755 %SOURCE4 %buildroot/%_initdir/courier-imapd-ssl
%__install -m 0755 %SOURCE5 %buildroot/%_initdir/courier-pop3d
%__install -m 0755 %SOURCE6 %buildroot/%_initdir/courier-pop3d-ssl

%__mkdir_p -m 0750 %buildroot/%_lockdir/%name
%__mkdir_p -m 0750 %buildroot/%courier_piddir
%__mkdir_p -m 0755 %buildroot/%_pemdir
touch %buildroot/%_pemdir/imapd.pem
touch %buildroot/%_pemdir/pop3d.pem

# Install additional documentation
#	authlib docs
%__install -m 0644 authlib/README.ldap %buildroot/%_docdir/%name-%version
%__install -m 0644 authlib/authldap.schema %buildroot/%_docdir/%name-%version
%__install -m 0644 authlib/README.authmysql.myownquery %buildroot/%_docdir/%name-%version
%__install -m 0644 authlib/authlib.html %buildroot/%_docdir/%name-%version/html
%__install -m 0644 authlib/README.authmysql.html %buildroot/%_docdir/%name-%version/html
%__install -m 0644 authlib/README.authpostgres.html %buildroot/%_docdir/%name-%version/html

#	imap docs
%__install -m 0644 imap/BUGS %buildroot/%_docdir/%name-%version/BUGS.imap
%__install -m 0644 imap/ChangeLog %buildroot/%_docdir/%name-%version/Changelog.imap
%__install -m 0644 imap/FAQ %buildroot/%_docdir/%name-%version/FAQ.imap
%__install -m 0644 imap/README %buildroot/%_docdir/%name-%version/README.imap
%__install -m 0644 imap/FAQ.html %buildroot/%_docdir/%name-%version/FAQ.imap.html
%__install -m 0644 imap/README.html %buildroot/%_docdir/%name-%version/README.imap.html
%__install -m 0644 imap/courierpop3d.html %buildroot/%_docdir/%name-%version/html/pop3d.html
%__install -m 0644 imap/mkimapdcert.html %buildroot/%_docdir/%name-%version/html
%__install -m 0644 imap/mkpop3dcert.html %buildroot/%_docdir/%name-%version/html

#	maildir docs
%__install -m 0644 maildir/AUTHORS %buildroot/%_docdir/%name-%version/AUTHORS.maildir
%__install -m 0644 maildir/INSTALL %buildroot/%_docdir/%name-%version/INSTALL.maildir
%__install -m 0644 maildir/README.maildirquota.txt %buildroot/%_docdir/%name-%version
%__install -m 0644 maildir/README.sharedfolders.txt %buildroot/%_docdir/%name-%version
%__install -m 0644 maildir/deliverquota.html %buildroot/%_docdir/%name-%version/html
%__install -m 0644 maildir/maildirquota.html %buildroot/%_docdir/%name-%version/html
%__install -m 0644 maildir/README.maildirfilter.html %buildroot/%_docdir/%name-%version/html
%__install -m 0644 maildir/README.maildirquota.html %buildroot/%_docdir/%name-%version/html
%__install -m 0644 maildir/README.sharedfolders.html %buildroot/%_docdir/%name-%version/html

#	rfc2045 docs
%__install -m 0644 rfc2045/makemime.html %buildroot/%_docdir/%name-%version/html
%__install -m 0644 rfc2045/reformime.html %buildroot/%_docdir/%name-%version/html
%__install -m 0644 rfc2045/rfc2045.html %buildroot/%_docdir/%name-%version/html

#	rfc822 docs
%__install -m 0644 rfc822/ChangeLog %buildroot/%_docdir/%name-%version/ChangeLog.rfc822
%__install -m 0644 rfc822/rfc822.html %buildroot/%_docdir/%name-%version/html

#	tcpd docs
%__install -m 0644 tcpd/README.couriertls %buildroot/%_docdir/%name-%version
%__install -m 0644 tcpd/couriertcpd.html %buildroot/%_docdir/%name-%version/html
%__install -m 0644 tcpd/couriertls.html %buildroot/%_docdir/%name-%version/html

#	unicode docs
%__install -m 0644 unicode/README %buildroot/%_docdir/%name-%version/README.unicode

#	userdb docs
%__install -m 0644 userdb/makeuserdb.html %buildroot/%_docdir/%name-%version/html
%__install -m 0644 userdb/userdb.html %buildroot/%_docdir/%name-%version/html
%__install -m 0644 userdb/userdbpw.html %buildroot/%_docdir/%name-%version/html

#	main package docs
%__install -m 0644 AUTHORS %buildroot/%_docdir/%name-%version
%__install -m 0644 ChangeLog %buildroot/%_docdir/%name-%version
%__install -m 0644 COPYING %buildroot/%_docdir/%name-%version
%__install -m 0644 INSTALL %buildroot/%_docdir/%name-%version
%__install -m 0644 NEWS %buildroot/%_docdir/%name-%version
%__install -m 0644 README %buildroot/%_docdir/%name-%version
%__install -m 0644 README.cygwin %buildroot/%_docdir/%name-%version
%__install -m 0644 INSTALL.html %buildroot/%_docdir/%name-%version/html
%__install -m 0644 index.html %buildroot/%_docdir/%name-%version/html

%post
# adjust config for generating SSL certs
HOSTNAME=`hostname -f`
for i in `ls %_sysconfdir/%name/*.cnf`; do
    %__subst "s|^CN=.*$|CN=$HOSTNAME|g;s|^emailAddress=.*$|emailAddress=root@$HOSTNAME|g" $i
done

# generate SSL certs
for i in imapd pop3d; do
    if [ ! -f %_pemdir/$i.pem ]; then
	echo -n "Generating SSL cert for $i-ssl: "
	cmd="%_datadir/%name/mk"$i"cert"
	$cmd >/dev/null 2>&1
	echo "%_pemdir/$i.pem - done."
    fi
done


%post_service courier-authdaemon
%post_service courier-imapd
%post_service courier-pop3d
%post_service courier-imapd-ssl
%post_service courier-pop3d-ssl

%preun
%preun_service courier-authdaemon
%preun_service courier-imapd
%preun_service courier-pop3d
%preun_service courier-imapd-ssl
%preun_service courier-pop3d-ssl

%files
%_initdir/courier-authdaemon
%_initdir/courier-imapd
%_initdir/courier-pop3d
%_initdir/courier-imapd-ssl
%_initdir/courier-pop3d-ssl
%dir %_sysconfdir/%name
%config %_sysconfdir/%name/authdaemon.conf
%config %_sysconfdir/%name/imapd
%config %_sysconfdir/%name/pop3d
%config %_sysconfdir/%name/imapd-ssl
%config %_sysconfdir/%name/pop3d-ssl
%config(noreplace) %_sysconfdir/%name/imapd.cnf
%config(noreplace) %_sysconfdir/%name/pop3d.cnf
%config(noreplace) %_sysconfdir/pam.d/imap
%config(noreplace) %_sysconfdir/pam.d/pop3
%config(noreplace) %_sysconfdir/sysconfig/%name
%_sbindir/couriertls
%_sbindir/imapd
%_sbindir/pop3d
%_sbindir/imaplogin
%_sbindir/pop3login
%_sbindir/courierlogger
%_sbindir/couriertcpd
%dir %_libdir/%name
%dir %_libdir/%name/authlib
%_libdir/%name/authlib/authdaemon
%_libdir/%name/authlib/authdaemond.plain
%dir %_datadir/%name
%_datadir/%name/mkimapdcert
%_datadir/%name/mkpop3dcert
%_man7dir/authcram.7*
%_man7dir/authdaemon.7*
%_man7dir/authdaemond.7*
%_man7dir/authldap.7*
%_man7dir/authlib.7*
%_man7dir/authmysql.7*
%_man7dir/authpam.7*
%_man7dir/authpwd.7*
%_man7dir/authshadow.7*
%_man7dir/authuserdb.7*
%_man7dir/authvchkpw.7*
%_man8dir/couriertcpd.8*
%_man8dir/couriertls.8*
%_man8dir/imapd.8*
%_man8dir/mkimapdcert.8*
%_man8dir/mkpop3dcert.8*
%_man8dir/pop3d.8*
%dir %attr(0750,root,root) %_localstatedir/%name
%dir %attr(0750,root,root) %_lockdir/%name
%ghost %attr(0600,root,root) %config(noreplace,missingok) %_pemdir/imapd.pem
%ghost %attr(0600,root,root) %config(noreplace,missingok) %_pemdir/pop3d.pem
#
%dir %_docdir/%name-%version
%doc %_docdir/%name-%version/*

%files ldap
%config(noreplace) %_sysconfdir/%name/authdaemon-ldap.conf
%_libdir/%name/authlib/authdaemond.ldap

%files mysql
%config(noreplace) %_sysconfdir/%name/authdaemon-mysql.conf
%_libdir/%name/authlib/authdaemond.mysql

%files pgsql
%config(noreplace) %_sysconfdir/%name/authdaemon-pgsql.conf
%_libdir/%name/authlib/authdaemond.pgsql

%files utils
# utils for maildir
%dir %_sysconfdir/%name
%_sysconfdir/%name/quotawarnmsg.example
%_bindir/maildirmake
%_sbindir/deliverquota
%_sbindir/makeuserdb
%_sbindir/userdb
%_sbindir/userdbpw
%_mandir/man1/maildirmake.1*
%_mandir/man8/deliverquota.8*
# common-courier-utils for userdb
%_man8dir/makeuserdb.8*
%_man8dir/pw2userdb.8*
%_man8dir/userdb.8*
%_man8dir/userdbpw.8*
%_man8dir/vchkpw2userdb.8*
%dir %_datadir/%name
%_datadir/%name/makedatprog
%_datadir/%name/makeuserdb
%_datadir/%name/pw2userdb
%_datadir/%name/userdb
%_datadir/%name/vchkpw2userdb

%changelog
* Tue Feb 11 2003 Dmitry Lebkov <dlebkov@altlinux.ru> 1.6.2-alt3
- spec-file fix:
  + provide abstract IMAPD & POP3D services (as virtual pkgs) and
    describe the relations with other such pkgs (fixes #2168 at
    bugs.altlinux.ru);

* Sat Feb 01 2003 Dmitry Lebkov <dlebkov@altlinux.ru> 1.6.2-alt2
- SSL/TLS certs generation during package install
- fix paths for .lock, .pid and .pem files according to
  FHS and ALT policy
- courier-imap-doc removed, documentation is moved into courier-imap
- spec-file cleanup

* Mon Jan 06 2003 Dmitry Lebkov <dlebkov@altlinux.ru> 1.6.2-alt1
- 1.6.2
- pop3d/imapd daemons logging improvement
- spec-file fixes

* Tue Oct 29 2002 Dmitry Lebkov <dlebkov@altlinux.ru> 1.5.3-alt2
- fix 'post' and 'preun' sections of the spec-file
- add 'START_AUTHD' variable to /etc/sysconfig/courier-imap
  This variable is checked by courier-authdaemon script

* Wed Sep 11 2002 Dmitry Lebkov <dlebkov@altlinux.ru> 1.5.3-alt1
- initial package for ALT Linux
